unit f_speed_test;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  BGRAGraphicControl, BGRAVirtualScreen, BGRABitmap, BCTypes, BGRABitmapTypes,
  LCLIntf, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BGRAGraphicControl1: TBGRAGraphicControl;
    Timer1: TTimer;
    procedure myRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    x_pos, y_pos : Integer;
    FpsCounter : Integer;
    FpsTime : UInt64;
  public
    FpsRate : Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }
procedure TForm1.myRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  // Black Background
  Bitmap.FillRect(0, 0, Bitmap.Width, Bitmap.Height, clBlackOpaque);

  // Draw FPS
  Bitmap.FontHeight := 30;
  Bitmap.FontStyle := [fsBold];
  Bitmap.TextOut(Bitmap.Width div 2,(Bitmap.Height div 2) - (Bitmap.FontFullHeight div 2),
                 'FPS: ' + IntToStr(FpsRate),
                 clWhite,taCenter);

  // To visualize performance
  Bitmap.EllipseAntialias(x_pos , y_pos, 10, 10, BGRAWhite, 2);
  Inc(x_pos, 1);
  if x_pos > Width
  then x_pos := 0;

  // Calculate FPS
  if GetTickCount64 - FpsTime >= 2000
  then begin
    FpsRate:=FpsCounter div 2;
    FpsCounter:=1;
    FpsTime:=GetTickCount64;

    // To visually verify interval
    Inc(y_pos, 10);
    if y_pos > Height-20
    then y_pos := 20;
  end
  else Inc(FpsCounter);

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  BGRAGraphicControl1.RedrawBitmap;            // <-- Flip these
  //BGRAVirtualScreen1.RedrawBitmap;           // <-- Flip these
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BGRAGraphicControl1.Align := alClient;       // <-- Flip these
  //BGRAVirtualScreen1.Align := alClient;      // <-- Flip these

  BGRAGraphicControl1.OnRedraw := @myRedraw;   // <-- Flip these
  //BGRAVirtualScreen1.OnRedraw := @myRedraw;  // <-- Flip these

  Timer1.Interval := 1;
  FpsTime := GetTickCount64;
  x_pos:=0;
  y_pos:=20;
end;



end.

